
screen 0
goto start
'subs
newadd:
pc=pc+1
if (d and 128)=0 then pc=pc+d else pc=pc-(d xor &hff)
return


chka:
if a=0 then zero=1 else zero=0
if a>127 then sign=1 else sign=0
return

chkx:
if x=0 then zero=1 else zero=0
if x>127 then sign=1 else sign=0
return

chky:
if y=0 then zero=1 else zero=0
if y>127 then sign=1 else sign=0
return

chkz:
if z=0 then zero=1 else zero=0
if z>127 then sign=1 else sign=0
return

interp: 'interpet opcode
? number
select case number

 case &h10 'bpl
  if sign=0 then gosub newadd
 case &h30 'bmi
  if sign=1 then gosub newadd
 case &h50 'bvc
  if overflow=0 then gosub newadd
 case &h70 'bvs
  if overflow=1 then gosub newadd
 case &h90 'bcc
  if carry=0 then gosub newadd
 case &hb0 'bcs
  if carry=1 then gosub newadd
 case &hd0 'bne
  if zero=0 then gosub newadd
 case &hf0 'beq
  if zero=1 then gosub newadd
 case &h18 'clc
  carry=0
 case &h38 'sec
  carry=1
 case &h58 'cli
  interupt=0
 case &h78 'sei
  interupt=1
 case &hb8 'clv
  overflow=0
 case &hd8 'cld
  decimal=0
 case &hf8 'sed
  decimal=1
 case &h88 'dey
  y=y-1:if y<0 then y=&hff
  gosub chky
 case &hc8 'iny
  y=y+1:if y>&hff then y=0
  gosub chky
 case &hca 'dex
  x=x-1:if x<0 then x=&hff
  gosub chkx
 case &he8 'inx
  x=x+1:if x>&hff then x=0
  gosub chkx
 case &h98 'tya
  a=y
  gosub chka
 case &ha8 'tay
  y=a
  gosub chka
 case &h8a 'txa
  a=x
  gosub chka
 case &h9a 'txs
  sp=x
 case &haa 'tax
  x=a
  gosub chka
 case &hba 'tsx
  x=sp
  gosub chkx
 case &hea 'nop
  'no operation!
 case &h09 'ora
  a=a or d
  pc=pc+1
  gosub chka
 case &h29 'and
  a=a and d
  pc=pc+1
  gosub chka
 case &h49 'eor
  a=a xor d
  pc=pc+1
  gosub chka
 case &ha9 'lda
  a=d
  pc=pc+1
  gosub chka
 case &ha2 'ldx
  x=d
  pc=pc+1
  gosub chkx
 case &ha0 'ldy
  y=d
  pc=pc+1
  gosub chky
 case &h60 'rts
  sp=sp+1:pc=s(sp):sp=sp+1
  pc=pc+(s(sp)*256)
 case &h20 'jsr
  s(sp)=int((pc+2)/256):sp=sp-1
  s(sp)=(pc+2)-s(sp+1)*256:sp=sp-1
  pc=dd-1
 case &h48 'pha
  s(sp)=a:sp=sp-1
 case &h68 'pla
  sp=sp+1:a=s(sp)
 case &h4c 'jmp
  pc=dd-1
 case &h6c '(jmp)
  pc=m(m(pc+1))+m(m(pc+2))*256
 case &ha5 'lda zp
  a=m(d):pc=pc+1
  gosub chka
 case &hb5 'lda zp,x
  a=m(d+x):pc=pc+1
  gosub chka
 case &had 'lda abs
  a=m(dd):pc=pc+2
  gosub chka
 case &hbd 'lda abs,x
  a=m(dd+x):pc=pc+2
  gosub chka
 case &hb9 'lda abs,y
  a=m(dd+y):pc=pc+2
  gosub chka
 case &ha6 'ldx zp
  x=m(d):pc=pc+1
  gosub chkx
 case &hb6 'ldx zp,y
  x=m(d+y):pc=pc+1
  gosub chkx
 case &hae 'ldx abs
  x=m(dd):pc=pc+2
  gosub chkx
 case &hbe 'ldx abs,y
  x=m(dd+y):pc=pc+2
  gosub chkx
 case &ha4 'ldy zp
  y=m(d):pc=pc+1
  gosub chky
 case &hb4 'ldy zp,x
  y=m(d+y):pc=pc+1
  gosub chky
 case &hac 'ldy abs
  y=m(dd):pc=pc+2
  gosub chky
 case &hbc 'ldy abs,x
  y=m(dd+x):pc=pc+2
  gosub chky
 case &h8d 'sta
  m(dd)=a:pc=pc+2
 case &h55 'sta zp
  m(d)=a:pc=pc+1
 case &h95 'sta zp,x
  m(d+x)=a:pc=pc+1
 case &h9d 'sta abs,x
  m(dd+x)=a:pc=pc+2
 case &h99 'sta abs,y
  m(dd+y)=a:pc=pc+2
 case &h86 'stx zp
  m(d)=x:pc=pc+1
 case &h96 'stx zp,y
  m(d+y)=x:pc=pc+1
 case &h8e 'stx abs
  m(dd)=x:pc=pc+2
 case &h84 'sty zp
  m(d)=y:pc=pc+1
 case &h94 'sty zp,x
  m(d+x)=y:pc=pc+1
 case &h8c 'sty abs
  m(dd)=y:pc=pc+2
 case &h25 'and zp
  a=a and m(d):pc=pc+1
  gosub chka
 case &h35 'and zp,x
  a=a and m(d+x):pc=pc+1
  gosub chka
 case &h2d 'and abs
  a=a and m(dd):pc=pc+2
  gosub chka
 case &h3d 'and abs,x
  a=a and m(dd+x):pc=pc+2
  gosub chka
 case &h39 'and abs,y
  a=a and m(dd+y):pc=pc+2
  gosub chka
 case &h45 'eor zp
  a=a xor m(d):pc=pc+1
  gosub chka
 case &h55 'eor zp,x
  a=a xor m(d+x):pc=pc+1
  gosub chka
 case &h4d 'eor abs
  a=a xor m(dd):pc=pc+2
  gosub chka
 case &h5d 'eor abs,x
  a=a xor m(dd+x):pc=pc+2
  gosub chka
 case &h59 'eor abs,y
  a=a xor m(dd+y):pc=pc+2
  gosub chka
 case &h05 'ora zp
  a=a or m(d):pc=pc+1
  gosub chka
 case &h15 'ora zp,x
  a=a or m(d+x):pc=pc+1
  gosub chka
 case &h0d 'ora abs
  a=a or m(dd):pc=pc+2
  gosub chka
 case &h1d 'ora abs,x
  a=a or m(dd+x):pc=pc+2
  gosub chka
 case &h19 'ora abs,y
  a=a or m(dd+y):pc=pc+2
  gosub chka
 case &hc6 'dec zp
  m(d)=m(d)-1:if m(d)<0 then m(d)=&hff
  z=m(d):gosub chkz:pc=pc+1
 case &hd6 'dec zp,x
  m(d+x)=m(d+x)-1:if m(d+x)<0 then m(d+x)=&hff
  z=m(d+x):gosub chkz:pc=pc+1
 case &hce 'dec abs
  m(dd)=m(dd)-1:if m(dd)<0 then m(dd)=&hff
  z=m(dd):gosub chkz:pc=pc+2
 case &hde 'dec abs,x
  m(dd+x)=m(dd+x):if m(dd+x)<0 then m(dd+x)=&hff
  z=m(dd+x):gosub chkz:pc=pc+2
 case &he6 'inc zp
  m(d)=m(d)+1:if m(d)>&hff then m(d)=0
  z=m(d):gosub chkz:pc=pc+1
 case &hf6 'inc zp,x
  m(d+x)=m(d+x):if m(d+x)>&hff then m(d+x)=0
  z=m(d+x):gosub chkz:pc=pc+1
 case &hee 'inc abs
  m(dd)=m(dd)+1:if m(dd)>&hff then m(dd)=0
  z=m(dd):gosub chkz:pc=pc+2
 case &hfe 'inc abs,x
m(dd+x)=m(dd+x)+1:if m(dd+x)>&hff then m(dd+x)=0
  z=m(dd+x):gosub chkz:pc=pc+2
 case &h24 'bit zp
  z=m(d) and a
  if z=0 then zero=1 else zero=0
  if z and &h80=&h80 then sign=1 else sign=0
  if z and &h40=&h40 then oflow=1 else oflow=0
  pc=pc+1
 case &h2c 'bit abs
  z=m(dd) and a
  if z=0 then zero=1 else zero=0
  if z and &h80=&h80 then sign=1 else sign=0
  if z and &h40=&h40 then oflow=1 else oflow=0
  pc=pc+2
 case &h0a 'asl
  a=a*2
  if a>&hff then carry=1:a=a and &hff else carry=0
  gosub chka
 case &h06 'asl zp
  m(d)=m(d)*2
  if m(d)>&hff then carry=1:m(d)=m(d) and &hff else carry=0
  z=m(d):gosub chkz:pc=pc+1
 case &h16 'asl zp,x
  m(d+x)=m(d+x)*2
  if m(d+x)>&hff then carry=1:m(d+x)=m(d+x) and &hff else carry=0
  z=m(d+x):gosub chkz:pc=pc+1
 case &h0e 'asl abs
  m(dd)=m(dd)*2
  if m(dd)>&hff then carry=1:m(dd)=m(dd) and &hff else carry=0
  z=m(dd):gosub chkz:pc=pc+2
 case &h1e 'asl abs,x
  m(dd+x)=m(dd+x)*2
  if m(dd+x)>&hff then carry=1:m(dd+x)=m(dd+x) and &hff else carry=0
  z=m(dd+x):gosub chkz:pc=pc+2
 case &h2a 'rol
  a=a*2:z=carry
  if a>&hff then carry=1:a=a and &hff else carry=0
  a=a+z:gosub chka
 case &h26 'rol zp
  m(d)=m(d)*2:z=carry
  if m(d)>&hff then carry=1:m(d)=m(d) and &hff else carry=0
  m(d)=m(d)+z:z=m(d):gosub chkz:pc=pc+1
 case &h36 'rol zp,x
  m(d+x)=m(d+x)*2:z=carry
  if m(d+x)>&hff then carry=1:m(d+x)=m(d+x) and &hff else carry=0
  m(d+x)=m(d+x)+z:z=m(d+x):gosub chkz:pc=pc+1
 case &h2e 'rol abs
  m(dd)=m(dd)*2:z=carry
  if m(dd)>&hff then carry=1:m(dd)=m(dd) and &hff else carry=0
  m(dd)=m(dd)+z:z=m(dd):gosub chkz:pc=pc+2
 case &h3e 'rol abs,x
  m(dd+x)=m(dd+x)*2:z=carry
  if m(dd+x)>&hff then carry=1:m(dd+x)=m(dd+x) and &hff else carry=0
  m(dd+x)=m(dd+x)+z:z=m(dd+x):gosub chkz:pc=pc+2
 case &h4a 'lsr
  a=a/2
  if a>int(a) then a=int(a):carry=1 else carry=0
  gosub chka
 case &h46 'lsr ap
  m(d)=m(d)/2
  if m(d)>int(m(d)) then m(d)=int(m(d)):carry=1 else carry=0
  z=m(d):gosub chkz:pc=pc+1
 case &h56 'lsr zp,x
  m(d+x)=m(d+x)/2
  if m(d+x)>int(m(d+x)) then m(d+x)=int(m(d+x)):carry=1 else carry=0
  z=m(d+x):gosub chkz:pc=pc+1
 case &h4e 'lsr abs
  m(dd)=m(dd)/2
  if m(dd)>int(m(dd)) then m(dd)=int(m(dd)):carry=1 else carry=0
  z=m(dd):gosub chkz:pc=pc+2
 case &h5e 'lsr abs,x
  m(dd+x)=m(dd+x)/2
  if m(dd+x)>int(m(dd)) then m(dd+x)=int(m(dd+x)):carry=1 else carry=0
  z=m(dd+x):gosub chkz:pc=pc+2


end select
return

start:
pc=0000
a=0
x=0
y=0
sp=8

data &h4c,&h06,&h00,&ha9,&hf0,&h60,&h88,&h20,&h03,&h00,&hea,&hff

mm=0
while z<>&hff
read z
mm=mm+1
wend

dim m(4096)
restore
for z=0 to mm-1:read m(z):next

continu:
number=m(pc)
d=m(pc+1)
dd=m(pc+2)*256+m(pc+1)
gosub interp
pc=pc+1
gosub show
if pc=>mm then goto thatsit
a$=""
while a$=""
a$=inkey$:if a$="q" then end
wend
goto continu

thatsit:
?"A=";hex$(a)
?"X=";hex$(x)
?"Y=";hex$(y)
?"PC=";hex$(pc)
?"SP=";hex$(sp)
'?zero;carry;interupt;overflow;sign
end

show:
print  "A=";hex$(a);
print  " X=";hex$(x);
print  " Y=";hex$(y);
print  " SP=";hex$(sp)
print  "PC=";hex$(pc);zero;carry;interupt;overflow;sign
?
return
