                     .org h'0000
                     .equ opladr,0
                     .equ opldat,1

                     
                     
                     jmp start
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst1               ;rst 1
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst2               ;rst 2
                     nop
                     nop
                     nop
                     nop
                     nop                    
                     jmp rst3               ;rst 3
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst4               ;rst 4
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst5               ;rst 5
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst6               ;rst 6
                     nop
                     nop
                     nop
                     nop
                     nop
                     jmp rst7               ;rst 7
                     nop

interrupt:           nop
                     ei
                     ret


;load acc into register b

rst1:                push psw
                     mov a,b
                     
rst1cont:            out opladr
                     nop
                     nop
                     nop
                     nop
                     pop psw
                     out opldat
                     ret

; out acc to (b=reg c=chan)

rst2:                push psw
                     push h
                     push b
                     lxi h,op2cell
                     mvi b,0
                     dad b
                     pop b
                     mov a,m
                     add b
                     pop h
                     jmp rst1cont

;out acc to (b=reg c=chan)

rst3:                push psw
                     mov a,c
                     add b
                     jmp rst1cont


weird_wrt:           push psw
                     mov a,c
                     sui 5
                     cpi 9
                     jnz *+5
                     mvi a,h'8
                     cpi 10
                     jnz *+5
                     mvi a,h'7
                     add b
                     jmp rst1cont


weird_wrt2:          push psw
                     push h
                     push b
                     lxi h,perc2cell-11
                     mvi b,0
                     dad b
                     pop b
                     mov a,m
                     add b
                     pop h
                     jmp rst1cont


;restarts a channel that is already going (if it is going)
;used by the porta routines

rst4:                lda mode
                     ora a
                     jz mel_mode3
                     mov a,c
                     sui 6
                     jc its_ok3
                     sui 5
                     rc
                     mvi b,0
                     lxi h,perc_bits
                     dad b
                     lda bd_reg
                     ana m
                     rz               ;if perc not playing, quit
                     lxi h,old_notes
                     dad b
                     mov l,m

                     call do_note
                     push b
                     mvi b,h'a0
                     call weird_wrt   ; load lower 8 bits.
                     mov a,e
                     rlc
                     rlc
                     ora m
                     pop b
                     mvi b,h'b0
                     call weird_wrt    ;load upper two bits+oct.
                     ret


mel_mode3:           mov a,c
                     sui 9
                     rnc
                     
its_ok3:             lxi h,old3
                     mvi b,0
                     dad b
                     mvi a,h'20
                     ana m
                     rz           ; quit 'cause channel is stopped
                     lxi h,old_notes
                     dad b
                     mov l,m
                     call do_note

                     
                     
                     push b
                     mvi b,h'a0
                     rst 3
                     mov a,e
                     rlc
                     rlc
                     ora m
                     pop b
                     mvi b,h'b0
                     ori h'20
                     rst 3
                     ret


do_note:             mvi h,0
                     mvi a,12
                     call hlbya   ; get note/octave
                     mvi e,0
                     ana a
                     rar
                     mov d,a
                     mov a,e
                     rar
                     mov e,a          ;de holds correct table offset
                     push b
                     push h
                     lxi h,bend
                     mvi b,0
                     dad b
                     mvi a,h'80
                     ana m
                     jz *+5
                     mvi b,h'ff
                     mov c,m
                     xchg
                     dad b
                     mvi a,h'80
                     ana h
                     
                     jnz too_small
                     pop d
                     inr e
                     push d
                     lxi d,-1536
                     dad d
                     jnc too_small
                     jmp ts_done

too_small:           lxi d,1536                     
                     dad d
                     pop d
                     dcr e
                     push d
                     
ts_done:             mvi a,h'fe
                     ana l
                     mov l,a
                     pop d
                     lxi b,notes
                     dad b            ;get offset
                     mov a,m
                     inx h
                     pop b
                     ret

;shuts up channel c

rst5:                lda mode
                     ora a
                     jz mel_mode2
                     mov a,c
                     sui 6
                     jc its_ok2
                     sui 5
                     rc
                     mov c,a        ;c holds 0-4, for bass drum to hi-hat
                     lxi h,rev_perc
                     mvi b,0
                     dad b
                     lda bd_reg
                     ana m
                     sta bd_reg     ;clear the correct perc. bit
                     push psw
                     mvi a,h'bd
                     jmp rst1cont

mel_mode2:           mov a,c
                     sui 9         ;if >8 then return
                     rnc

its_ok2:             mvi b,0
                     lxi h,old3
                     dad b
                     mov a,m
                     ani h'1f
                     mov m,a
                     mvi b,h'b0
                     rst 3
                     ret

;play note acc on chan c w/ vol b

special_on:          lxi h,old_notes2
                     push b
                     mvi b,0
                     dad b
                     mov m,a
                     pop b

rst6:                lxi h,old_notes
                     push b
                     mvi b,0
                     dad b
                     mov m,a
                     pop b
                     mov l,a
                     mvi h,0
                     lda mode
                     ora a
                     jz mel_mode
                     mov a,c
                     sui 6
                     jc its_ok
                     sui 5
                     rc
                     jmp perc_mode    ;c- ins 11-15 for bass to hi-hat


perc_mode:           
                     call do_note
                     
                     push b
                     mvi b,h'a0
                     call weird_wrt   ; load lower 8 bits.
                     mov a,e
                     rlc
                     rlc
                     ora m
                     pop b
                     push b
                     mvi b,h'b0
                     call weird_wrt    ;load upper two bits+oct.
                     pop b
                     push b
                     lxi h,old3
                     mov e,c
                     mvi d,0
                     dad d
                     mov m,a           ;save reg info
                     lxi h,old1
                     dad d
                     mov a,m          ;a holds volume, b holds max vol.
                     cma
                     ani h'3f   
                     mov h,a
                     mov a,b
                     rlc
                     mov b,a
                     call mul8by8
                     mov a,h
                     cma
                     ani h'3f
                     mov h,a
                     mvi a,h'c0
                     push h
                     lxi h,old1
                     dad d
                     ana m
                     pop h
                     ora h
                     mov c,e
                     lxi h,perc2cell-11
                     dad d
                     push psw
                     mvi a,h'40
                     add m
                     mov b,a
                     pop psw
                     rst 1
                     
                     pop b
                     lxi h,rev_perc-11
                     dad d
                     lda bd_reg
                     ana m
                     mvi b,h'bd
                     rst 1
                     lxi h,perc_bits-11
                     dad d
                     ora m
                     sta bd_reg
                     push psw
                     mvi a,h'bd
                     jmp rst1cont



mel_mode:            mov a,c
                     sui 9          ;if >8 then return
                     rnc

its_ok:              call do_note

                     push b
                     mvi b,h'a0
                     rst 3            ;load lower 8 bits of note value
                     
                     mov a,e
                     rlc
                     rlc
                     ora m
                     pop b
                     
                     
                     push b
                     mvi b,h'b0
                     rst 3            ;load upper 2 bits+octave
                     
                     
                     pop b
                     push b
                     lxi h,old3
                     mov e,c
                     mvi d,0
                     dad d
                     mov m,a
                     
                     
                     lxi h,old1
                     dad d
                     mov a,m          ;a holds volume, b holds max vol.
                     cma
                     ani h'3f   
                     mov h,a
                     mov a,b
                     rlc
                     mov b,a
                     call mul8by8
                     mov a,h
                     cma
                     ani h'3f
                     mov h,a
                     mvi a,h'c0
                     push h
                     lxi h,old1
                     dad d
                     ana m
                     pop h
                     ora h
                     mov c,e
                     mvi b,h'43
                     rst 2
                     
                     lxi h,old2
                     dad d
                     mvi a,1
                     ana m
                     jz no_change2
            
                     push b
                     pop b
                     lxi h,old0
                     dad d
                     mov a,m          ;a holds volume, b holds max vol.
                     cma
                     ani h'3f   
                     mov h,a
                     mov a,b
                     rlc
                     mov b,a
                     call mul8by8
                     mov a,h
                     cma
                     ani h'3f
                     mov h,a
                     mvi a,h'c0
                     push h
                     lxi h,old0
                     dad d
                     ana m
                     pop h
                     ora h
                     mov c,e
                     mvi b,h'40
                     rst 2
                     
no_change2:          pop b
                     lxi h,old3
                     dad d
                     mov a,m
                     ori h'20
                     mov m,a
                     mvi b,h'b0
                     rst 3            ;gate the note on
                     ret

;load instrument acc  into chan c


rst7:                push b
                     push psw
                     rst 5
                     pop psw
                     mov c,a
                     mvi b,0
                     push b
                     ana a
                     mov a,c
                     ral
                     mov c,a
                     mov a,b
                     ral
                     mov b,a
                     push b
                     mov a,c
                     ral
                     mov c,a
                     mov a,b
                     ral
                     mov b,a
                     mov a,c
                     ral
                     mov c,a
                     mov a,b
                     ral
                     mov b,a
                     pop h
                     dad b
                     pop b
                     dad b      ;hl holds offset into instruments
                     xchg
                     lhld start_ins
                     dad d               ;hl stores start of instrument
                     pop b
                     mov a,c
                     cpi 6
                     jc dontcare
                     lda mode
                     ora a
                     jnz perc_load
                     
                     
dontcare:            cpi 9
                     rnc
                     mov a,m
                     inx h
                     mvi b,h'20
                     rst 2
                     

                     mov a,m
                     inx h
                     mvi b,h'23
                     rst 2


                     mov a,m
                     push h
                     lxi h,old0
                     mvi b,0
                     dad b
                     mov m,a
                     pop h
                     inx h
                     mvi b,h'40
                     rst 2
                     
                     mov a,m
                     push h
                     lxi h,old1
                     mvi b,0
                     dad b
                     mov m,a
                     pop h
                     inx h
                     mvi b,h'43
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'60
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'63
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'80
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'83
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'e0
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'e3
                     rst 2

                     mov a,m
                     lxi h,old2
                     mvi b,0
                     dad b
                     mov m,a
                     mvi b,h'c0
                     rst 3
                     ret 


perc_load:           sui 5
                     cpi 6
                     rc
                     mov a,c
                     cpi 16
                     rnc
                     mvi a,11
                     cmp c
                     jz bass_load
                     mov a,m
                     mvi b,h'20
                     call weird_wrt2
                     inx h
                     inx h
                     mov a,m
                     mvi b,h'40
                     call weird_wrt2
                     push h
                     mvi b,0
                     lxi h,old1
                     dad b
                     mov m,a
                     pop h
                     inx h
                     inx h
                     mov a,m
                     mvi b,h'60
                     call weird_wrt2
                     inx h
                     inx h
                     mvi b,h'80
                     call weird_wrt2
                     inx h
                     inx h
                     mvi b,h'e0
                     call weird_wrt2
                     inx h
                     inx h
                     mvi b,h'c0
                     call weird_wrt
                     ret


bass_load:           mov a,m
                     inx h
                     mvi b,h'20
                     mvi c,6
                     rst 2
                     

                     mov a,m
                     inx h
                     mvi b,h'23
                     rst 2


                     mov a,m
                     push h
                     lxi h,old0+11
                     mov m,a
                     pop h
                     inx h
                     mvi b,h'40
                     rst 2
                     
                     mov a,m
                     push h
                     lxi h,old1+11
                     mov m,a
                     pop h
                     inx h
                     mvi b,h'43
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'60
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'63
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'80
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'83
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'e0
                     rst 2
                     
                     mov a,m
                     inx h
                     mvi b,h'e3
                     rst 2

                     mov a,m
                     lxi h,old2+11
                     mov m,a
                     mvi b,h'c0
                     rst 3
                     ret 


;hl hold dividend
;a holds divisor

hlbya:  push    b           ; preserve what we use here
        push    d
        ora     a           ; test: trying to divide by zero?
        jz      divz        ; yes: don't allow... abort, return zeros
        mov     c,a         ; the divisor
        xra     a           ; a cheap zero for Accumulator
        mov     e,a         ; clear a place for the remainder
        ora     h           ; mingle in the dividend high & low bytes..
        ora     l           ; ..to test: dividing into zero?
        jz      divz        ; yes: abort, returning zeros
        mvi     b,16        ; the count of bits in the dividend
dbya1:  xra     a           ; cheap zero
        ora     b           ; bit-count now zero? (and clear carry!)
        jz      dbyao       ; yes: division is complete, so exit
        mov     a,l         ; the dividend low byte
        ral                 ; zero into HL.bit0, HL.bit7 into carry
        mov     l,a         ; updated low-byte
        mov     a,h         ; high byte of dividend
        ral                 ; carry to HL.bit8, HL.bit15 to carry
        mov     h,a         ; updated high-byte
        mov     a,e         ; fetch remainder byte
        ral                 ; put HL.bit15 (from carry) into E.bit0
        mov     e,a         ; updated remainder byte
        dcr     b           ; dividend bits count down
        cmp     c           ; test remainder with divisor
        jc      dbya1       ; loop back if remainder less than divisor
        sub     c           ; remainder minus divisor
        mov     e,a         ; remainder = remainder - divisor
        inx     h           ; increment to build the quotient
        jmp     dbya1       ; continue bit shifting
dbyao:  mov     a,e         ; remainder returned in A; result is HL
        pop     d           ; restore the registers we saved
        pop     b
        ret                 ; HLbyA end: return to caller
divz:   lxi     h,0         ; zero result if division by zero
        mov     e,l         ; and zero the remainder
        jmp     dbyao       ; exit HLbyA

mul8by8         push d
                mvi d,0
                mov l,d
                mov e,b
                mvi b,8 ; number of bits
                

mul_loop:       ana a
                mov a,l
                ral
                mov l,a
                mov a,h
                ral
                mov h,a
                jnc skip_mul
                dad d

skip_mul:       dcr b
                jnz mul_loop
                pop d
                ret


start:               lxi sp,0ffffh

                     xra a

clr_it:              mov b,a
                     push psw
                     xra a
                     rst 1
                     pop psw
                     dcr a
                     jnz clr_it

                     lxi h,h'2000    ;was 8000
                     mvi b,34       ;channels*2+2
                     lxi d,mode

mc_loop:             mov a,m
                     stax d
                     inx d
                     inx h
                     dcr b
                     jnz mc_loop
                     shld start_ins
                     lxi h,chan0
                     push h
                     pop d
                     mvi b,16

md_loop:             push b
                     mov c,m
                     inx h
                     mov b,m
                     inx h
                     push h
                     lxi h,h'2000   ;was 8000
                     dad b
                     mov a,l
                     stax d
                     inx d
                     mov a,h
                     stax d
                     inx d
                     pop h
                     pop b
                     dcr b
                     jnz md_loop
                     lxi h,old0
                     mvi b,80

me_loop:             mvi m,0
                     inx h
                     dcr b
                     jnz me_loop
                     lxi h,bend
                     mvi b,16

mf_loop:             mvi m,h'00
                     inx h
                     dcr b
                     jnz mf_loop
                     lxi h,dlay
                     mvi b,32

mg_loop:             mvi m,h'00
                     inx h
                     dcr b
                     jnz mg_loop
                     lda mode
                     ora a
                     mvi a,h'c0
                     jz *+5
                     mvi a,h'e0
                     sta bd_reg
                     mvi b,h'bd
                     rst 1        ; load bd reg w/ correct info
                     mvi b,h'04
                     mvi a,h'80
                     rst 1        ;reset timer
                     mvi b,h'03
                     mvi a,h'de   ;96 ticks/sec
                     rst 1
                     mvi b,h'04
                     mvi a,h'42
                     rst 1        ;start timer



mainloop:            call waitasec
                     lxi b,0

                                   ;get here

playloop:            lxi h,dlay
                     dad b
                     mov e,m
                     inx h
                     mov d,m
                     
playloop2:           mov a,d
                     ora e
                     jz time_up
                     dcx d
                     mov m,d
                     dcx h
                     mov m,e
                     inr c
                     inr c
                     mvi a,32
                     cmp c
                     jnz playloop
                     jmp mainloop

really_end:          mvi a,30
                     cmp c
                     lxi h,dlay
                     inx h
                     lxi d,1
                     jnz playloop2
                     hlt                 ;stop
                     ret


time_up:             lxi h,chan0
                     dad b
                     mov e,m
                     inx h
                     mov d,m
                     xchg
                     mov a,m
                     cpi h'80
                     jc note_on
                     cpi 249
                     jz same_old1
                     cpi 250
                     jz same_old2
                     cpi 251
                     jz same_old3
                     cpi 252
                     jz re_on
                     cpi 253
                     jz really_end
                     cpi 254
                     jz porta_dn
                     cpi 255
                     jz porta_up
                     ani h'7f
                     push h
                     push b
                     mov b,a
                     mov a,c
                     rrc
                     mov c,a
                     mov a,b
                     rst 7
                     pop b
                     pop h
                     jmp mus_done


porta_up:            inx h
                     mov a,m
                     push h
                     push b
                     mov b,a
                     mov a,c
                     rrc
                     mov c,a
                     mov a,b
                     push psw
                     push b
                     rst 4
                     pop b
                     pop psw
                     lxi h,bend
                     mvi b,0
                     dad b
                     mov m,a
                     pop b
                     pop h
                     jmp mus_done

porta_dn:            inx h
                     mov a,m
                     push h
                     push b
                     mov b,a
                     mov a,c
                     rrc
                     mov c,a
                     mov a,b
                     push psw
                     push b
                     rst 4
                     pop b
                     pop psw
                     lxi h,bend
                     mvi b,0
                     dad b
                     cma
                     inr a
                     mov m,a
                     pop b
                     pop h
                     jmp mus_done

re_on:               mvi a,h'69
                     ret

note_on:             inx h
                     mov a,m
                     ora a
                     dcx h
                     jz note_off
                     mov a,m
                     ora a
                     jz note_off
                     push b
                     mov a,c
                     rrc
                     mov c,a
                     mov a,m
                     inx h
                     mov b,m
                     sui 12
                     push h
                     call special_on
                     pop h
                     mov d,m
                     pop b
                     push b
                     push h
                     lxi h,old_vol
                     mov a,c
                     rrc
                     mov c,a
                     dad b
                     mov m,d
                     pop h
                     pop b
                     
                     inx h
                     lxi d,0
                     mov a,m
                     mov e,a
                     ora a
                     jz mus_done3
                     ani h'80
                     jz mus_done3
                     inx h
                     mov a,e
                     ani h'7f
                     mov d,a
                     mov a,m
                     rlc
                     mov e,a
                     mov a,d
                     ana a
                     rar
                     mov d,a
                     mov a,e
                     rar
                     mov e,a
                     jnc mus_done3
                     inx h
                     jmp mus_done3


note_off:            push h
                     push b
                     mov a,c
                     rrc
                     mov c,a
                     rst 5
                     pop b
                     pop h
                     jmp mus_done

;same except volume
same_old1:           inx h
                     push h
                     push b
                     mov d,m
                     mov a,c
                     rrc
                     mov c,a
                     lxi h,old_notes2
                     dad b
                     mov a,m
                     mov b,d
                     rst 6            ;turn note on
                     pop b
                     lxi h,old_dlay
                     dad b
                     mov e,m
                     inx h
                     mov d,m
                     pop h
                     jmp mus_done2

;same except note
same_old2:           inx h
                     push h
                     push b
                     mov e,m
                     mov a,c
                     rrc
                     mov c,a
                     lxi h,old_vol
                     dad b
                     mov b,m
                     mov a,e
                     sui 12
                     rst 6            ;turn note on
                     pop b
                     lxi h,old_dlay
                     dad b
                     mov e,m
                     inx h
                     mov d,m
                     pop h
                     jmp mus_done2

;same everything
same_old3:           push h
                     push b
                     mov a,c
                     rrc
                     mov c,a
                     lxi h,old_vol
                     dad b
                     mov d,m
                     lxi h,old_notes2
                     dad b
                     mov a,m
                     mov b,d
                     rst 6             ;turn note on
                     pop b
                     lxi h,old_dlay
                     dad b
                     mov e,m
                     inx h
                     mov d,m
                     pop h
                     jmp mus_done2

mus_done3:           inx h
                     push d
                     xchg
                     lxi h,chan0
                     dad b
                     mov m,e
                     inx h
                     mov m,d
                     pop d
                     lxi h,old_dlay
                     dad b
                     mov m,e
                     inx h
                     mov m,d
                     lxi h,dlay
                     dad b
                     inx h
                     jmp playloop2


mus_done:            inx h
                     lxi d,0
                     mov a,m
                     mov e,a
                     ora a
                     jz mus_done2
                     ani h'80
                     jz mus_done2
                     inx h
                     mov a,e
                     ani h'7f
                     mov d,a
                     mov a,m
                     rlc
                     mov e,a
                     mov a,d
                     ana a
                     rar
                     mov d,a
                     mov a,e
                     rar
                     mov e,a
                     jnc mus_done2
                     inx h


mus_done2:           inx h
                     push d
                     xchg
                     lxi h,chan0
                     dad b
                     mov m,e
                     inx h
                     mov m,d
                     pop d
                     lxi h,dlay
                     dad b
                     inx h
                     jmp playloop2





waitasec:            push b

ws_loop:             in opladr
                     ani h'20
                     jz ws_loop   ;wait for it to expire
                     pop b
                     
                     mvi b,h'04
                     mvi a,h'80
                     rst 1        ;reset timer
                     mvi b,h'03
                     mvi a,h'de   ;96 ticks/sec
                     rst 1
                     mvi b,h'04
                     mvi a,h'42
                     rst 1        ;start timer
                     
                     ret
                     


put_byte:       mvi d,8
                mvi a,h'40
                sim
                mvi c,h'3a

rl5:            dcr c
                jnz rl5

rl6:            mov a,b
                rrc
                mov b,a
                ani h'80
                ori h'40
                sim
                mvi c,h'3a

rl7:            dcr c
                jnz rl7
                dcr d
                jnz rl6
                mvi a,h'c0
                sim
                mvi c,h'77

rl8:            dcr c
                jnz rl8
                mvi a,h'8d
                sim
                ret



op2cell:             .db h'00,h'01,h'02,h'08,h'09,h'0a,h'10,h'11,h'12
                      
perc2cell:           .db h'13,h'14,h'12,h'15,h'11

perc_bits:           .db h'10,h'08,h'04,h'02,h'01

rev_perc:            .db h'ef,h'f7,h'fb,h'fd,h'fe

notes:                .db h'57,h'01,h'57,h'01,h'58,h'01,h'58,h'01
                      .db h'58,h'01,h'58,h'01,h'59,h'01,h'59,h'01
                      .db h'59,h'01,h'5A,h'01,h'5A,h'01,h'5A,h'01
                      .db h'5B,h'01,h'5B,h'01,h'5B,h'01,h'5C,h'01
                      .db h'5C,h'01,h'5C,h'01,h'5D,h'01,h'5D,h'01
                      .db h'5D,h'01,h'5D,h'01,h'5E,h'01,h'5E,h'01
                      .db h'5E,h'01,h'5F,h'01,h'5F,h'01,h'5F,h'01
                      .db h'60,h'01,h'60,h'01,h'60,h'01,h'61,h'01
                      .db h'61,h'01,h'61,h'01,h'62,h'01,h'62,h'01
                      .db h'62,h'01,h'63,h'01,h'63,h'01,h'63,h'01
                      .db h'64,h'01,h'64,h'01,h'64,h'01,h'64,h'01
                      .db h'65,h'01,h'65,h'01,h'65,h'01,h'66,h'01
                      .db h'66,h'01,h'66,h'01,h'67,h'01,h'67,h'01
                      .db h'67,h'01,h'68,h'01,h'68,h'01,h'68,h'01
                      .db h'69,h'01,h'69,h'01,h'69,h'01,h'6A,h'01
                      .db h'6A,h'01,h'6A,h'01,h'6B,h'01,h'6B,h'01
                      .db h'6B,h'01,h'6C,h'01,h'6C,h'01,h'6C,h'01
                      .db h'6D,h'01,h'6D,h'01,h'6D,h'01,h'6E,h'01
                      .db h'6E,h'01,h'6E,h'01,h'6F,h'01,h'6F,h'01
                      .db h'6F,h'01,h'70,h'01,h'70,h'01,h'70,h'01
                      .db h'71,h'01,h'71,h'01,h'71,h'01,h'72,h'01
                      .db h'72,h'01,h'72,h'01,h'73,h'01,h'73,h'01
                      .db h'73,h'01,h'74,h'01,h'74,h'01,h'74,h'01
                      .db h'75,h'01,h'75,h'01,h'75,h'01,h'76,h'01
                      .db h'76,h'01,h'76,h'01,h'77,h'01,h'77,h'01
                      .db h'77,h'01,h'78,h'01,h'78,h'01,h'78,h'01
                      .db h'79,h'01,h'79,h'01,h'79,h'01,h'7A,h'01
                      .db h'7A,h'01,h'7A,h'01,h'7B,h'01,h'7B,h'01
                      .db h'7B,h'01,h'7C,h'01,h'7C,h'01,h'7C,h'01
                      .db h'7D,h'01,h'7D,h'01,h'7D,h'01,h'7E,h'01
                      .db h'7E,h'01,h'7E,h'01,h'7F,h'01,h'7F,h'01
                      .db h'80,h'01,h'80,h'01,h'80,h'01,h'81,h'01
                      .db h'81,h'01,h'81,h'01,h'82,h'01,h'82,h'01
                      .db h'82,h'01,h'83,h'01,h'83,h'01,h'83,h'01
                      .db h'84,h'01,h'84,h'01,h'84,h'01,h'85,h'01
                      .db h'85,h'01,h'85,h'01,h'86,h'01,h'86,h'01
                      .db h'87,h'01,h'87,h'01,h'87,h'01,h'88,h'01
                      .db h'88,h'01,h'88,h'01,h'89,h'01,h'89,h'01
                      .db h'89,h'01,h'8A,h'01,h'8A,h'01,h'8A,h'01
                      .db h'8B,h'01,h'8B,h'01,h'8B,h'01,h'8C,h'01
                      .db h'8C,h'01,h'8D,h'01,h'8D,h'01,h'8D,h'01
                      .db h'8E,h'01,h'8E,h'01,h'8E,h'01,h'8F,h'01
                      .db h'8F,h'01,h'8F,h'01,h'90,h'01,h'90,h'01
                      .db h'91,h'01,h'91,h'01,h'91,h'01,h'92,h'01
                      .db h'92,h'01,h'92,h'01,h'93,h'01,h'93,h'01
                      .db h'93,h'01,h'94,h'01,h'94,h'01,h'95,h'01
                      .db h'95,h'01,h'95,h'01,h'96,h'01,h'96,h'01
                      .db h'96,h'01,h'97,h'01,h'97,h'01,h'97,h'01
                      .db h'98,h'01,h'98,h'01,h'99,h'01,h'99,h'01
                      .db h'99,h'01,h'9A,h'01,h'9A,h'01,h'9A,h'01
                      .db h'9B,h'01,h'9B,h'01,h'9C,h'01,h'9C,h'01
                      .db h'9C,h'01,h'9D,h'01,h'9D,h'01,h'9D,h'01
                      .db h'9E,h'01,h'9E,h'01,h'9E,h'01,h'9F,h'01
                      .db h'9F,h'01,h'A0,h'01,h'A0,h'01,h'A0,h'01
                      .db h'A1,h'01,h'A1,h'01,h'A1,h'01,h'A2,h'01
                      .db h'A2,h'01,h'A3,h'01,h'A3,h'01,h'A3,h'01
                      .db h'A4,h'01,h'A4,h'01,h'A5,h'01,h'A5,h'01
                      .db h'A5,h'01,h'A6,h'01,h'A6,h'01,h'A6,h'01
                      .db h'A7,h'01,h'A7,h'01,h'A8,h'01,h'A8,h'01
                      .db h'A8,h'01,h'A9,h'01,h'A9,h'01,h'A9,h'01
                      .db h'AA,h'01,h'AA,h'01,h'AB,h'01,h'AB,h'01
                      .db h'AB,h'01,h'AC,h'01,h'AC,h'01,h'AD,h'01
                      .db h'AD,h'01,h'AD,h'01,h'AE,h'01,h'AE,h'01
                      .db h'AE,h'01,h'AF,h'01,h'AF,h'01,h'B0,h'01
                      .db h'B0,h'01,h'B0,h'01,h'B1,h'01,h'B1,h'01
                      .db h'B2,h'01,h'B2,h'01,h'B2,h'01,h'B3,h'01
                      .db h'B3,h'01,h'B4,h'01,h'B4,h'01,h'B4,h'01
                      .db h'B5,h'01,h'B5,h'01,h'B6,h'01,h'B6,h'01
                      .db h'B6,h'01,h'B7,h'01,h'B7,h'01,h'B8,h'01
                      .db h'B8,h'01,h'B8,h'01,h'B9,h'01,h'B9,h'01
                      .db h'BA,h'01,h'BA,h'01,h'BA,h'01,h'BB,h'01
                      .db h'BB,h'01,h'BC,h'01,h'BC,h'01,h'BC,h'01
                      .db h'BD,h'01,h'BD,h'01,h'BE,h'01,h'BE,h'01
                      .db h'BE,h'01,h'BF,h'01,h'BF,h'01,h'C0,h'01
                      .db h'C0,h'01,h'C0,h'01,h'C1,h'01,h'C1,h'01
                      .db h'C2,h'01,h'C2,h'01,h'C2,h'01,h'C3,h'01
                      .db h'C3,h'01,h'C4,h'01,h'C4,h'01,h'C4,h'01
                      .db h'C5,h'01,h'C5,h'01,h'C6,h'01,h'C6,h'01
                      .db h'C6,h'01,h'C7,h'01,h'C7,h'01,h'C8,h'01
                      .db h'C8,h'01,h'C9,h'01,h'C9,h'01,h'C9,h'01
                      .db h'CA,h'01,h'CA,h'01,h'CB,h'01,h'CB,h'01
                      .db h'CB,h'01,h'CC,h'01,h'CC,h'01,h'CD,h'01
                      .db h'CD,h'01,h'CD,h'01,h'CE,h'01,h'CE,h'01
                      .db h'CF,h'01,h'CF,h'01,h'D0,h'01,h'D0,h'01
                      .db h'D0,h'01,h'D1,h'01,h'D1,h'01,h'D2,h'01
                      .db h'D2,h'01,h'D3,h'01,h'D3,h'01,h'D3,h'01
                      .db h'D4,h'01,h'D4,h'01,h'D5,h'01,h'D5,h'01
                      .db h'D5,h'01,h'D6,h'01,h'D6,h'01,h'D7,h'01
                      .db h'D7,h'01,h'D8,h'01,h'D8,h'01,h'D8,h'01
                      .db h'D9,h'01,h'D9,h'01,h'DA,h'01,h'DA,h'01
                      .db h'DB,h'01,h'DB,h'01,h'DB,h'01,h'DC,h'01
                      .db h'DC,h'01,h'DD,h'01,h'DD,h'01,h'DE,h'01
                      .db h'DE,h'01,h'DE,h'01,h'DF,h'01,h'DF,h'01
                      .db h'E0,h'01,h'E0,h'01,h'E1,h'01,h'E1,h'01
                      .db h'E1,h'01,h'E2,h'01,h'E2,h'01,h'E3,h'01
                      .db h'E3,h'01,h'E4,h'01,h'E4,h'01,h'E5,h'01
                      .db h'E5,h'01,h'E5,h'01,h'E6,h'01,h'E6,h'01
                      .db h'E7,h'01,h'E7,h'01,h'E8,h'01,h'E8,h'01
                      .db h'E8,h'01,h'E9,h'01,h'E9,h'01,h'EA,h'01
                      .db h'EA,h'01,h'EB,h'01,h'EB,h'01,h'EC,h'01
                      .db h'EC,h'01,h'EC,h'01,h'ED,h'01,h'ED,h'01
                      .db h'EE,h'01,h'EE,h'01,h'EF,h'01,h'EF,h'01
                      .db h'F0,h'01,h'F0,h'01,h'F0,h'01,h'F1,h'01
                      .db h'F1,h'01,h'F2,h'01,h'F2,h'01,h'F3,h'01
                      .db h'F3,h'01,h'F4,h'01,h'F4,h'01,h'F5,h'01
                      .db h'F5,h'01,h'F5,h'01,h'F6,h'01,h'F6,h'01
                      .db h'F7,h'01,h'F7,h'01,h'F8,h'01,h'F8,h'01
                      .db h'F9,h'01,h'F9,h'01,h'FA,h'01,h'FA,h'01
                      .db h'FA,h'01,h'FB,h'01,h'FB,h'01,h'FC,h'01
                      .db h'FC,h'01,h'FD,h'01,h'FD,h'01,h'FE,h'01
                      .db h'FE,h'01,h'FF,h'01,h'FF,h'01,h'FF,h'01
                      .db h'00,h'02,h'00,h'02,h'01,h'02,h'01,h'02
                      .db h'02,h'02,h'02,h'02,h'03,h'02,h'03,h'02
                      .db h'04,h'02,h'04,h'02,h'05,h'02,h'05,h'02
                      .db h'06,h'02,h'06,h'02,h'06,h'02,h'07,h'02
                      .db h'07,h'02,h'08,h'02,h'08,h'02,h'09,h'02
                      .db h'09,h'02,h'0A,h'02,h'0A,h'02,h'0B,h'02
                      .db h'0B,h'02,h'0C,h'02,h'0C,h'02,h'0D,h'02
                      .db h'0D,h'02,h'0E,h'02,h'0E,h'02,h'0E,h'02
                      .db h'0F,h'02,h'0F,h'02,h'10,h'02,h'10,h'02
                      .db h'11,h'02,h'11,h'02,h'12,h'02,h'12,h'02
                      .db h'13,h'02,h'13,h'02,h'14,h'02,h'14,h'02
                      .db h'15,h'02,h'15,h'02,h'16,h'02,h'16,h'02
                      .db h'17,h'02,h'17,h'02,h'18,h'02,h'18,h'02
                      .db h'19,h'02,h'19,h'02,h'1A,h'02,h'1A,h'02
                      .db h'1A,h'02,h'1B,h'02,h'1B,h'02,h'1C,h'02
                      .db h'1C,h'02,h'1D,h'02,h'1D,h'02,h'1E,h'02
                      .db h'1E,h'02,h'1F,h'02,h'1F,h'02,h'20,h'02
                      .db h'20,h'02,h'21,h'02,h'21,h'02,h'22,h'02
                      .db h'22,h'02,h'23,h'02,h'23,h'02,h'24,h'02
                      .db h'24,h'02,h'25,h'02,h'25,h'02,h'26,h'02
                      .db h'26,h'02,h'27,h'02,h'27,h'02,h'28,h'02
                      .db h'28,h'02,h'29,h'02,h'29,h'02,h'2A,h'02
                      .db h'2A,h'02,h'2B,h'02,h'2B,h'02,h'2C,h'02
                      .db h'2C,h'02,h'2D,h'02,h'2D,h'02,h'2E,h'02
                      .db h'2E,h'02,h'2F,h'02,h'2F,h'02,h'30,h'02
                      .db h'30,h'02,h'31,h'02,h'31,h'02,h'32,h'02
                      .db h'32,h'02,h'33,h'02,h'33,h'02,h'34,h'02
                      .db h'34,h'02,h'35,h'02,h'35,h'02,h'36,h'02
                      .db h'36,h'02,h'37,h'02,h'37,h'02,h'38,h'02
                      .db h'38,h'02,h'39,h'02,h'39,h'02,h'3A,h'02
                      .db h'3B,h'02,h'3B,h'02,h'3C,h'02,h'3C,h'02
                      .db h'3D,h'02,h'3D,h'02,h'3E,h'02,h'3E,h'02
                      .db h'3F,h'02,h'3F,h'02,h'40,h'02,h'40,h'02
                      .db h'41,h'02,h'41,h'02,h'42,h'02,h'42,h'02
                      .db h'43,h'02,h'43,h'02,h'44,h'02,h'44,h'02
                      .db h'45,h'02,h'45,h'02,h'46,h'02,h'46,h'02
                      .db h'47,h'02,h'48,h'02,h'48,h'02,h'49,h'02
                      .db h'49,h'02,h'4A,h'02,h'4A,h'02,h'4B,h'02
                      .db h'4B,h'02,h'4C,h'02,h'4C,h'02,h'4D,h'02
                      .db h'4D,h'02,h'4E,h'02,h'4E,h'02,h'4F,h'02
                      .db h'4F,h'02,h'50,h'02,h'51,h'02,h'51,h'02
                      .db h'52,h'02,h'52,h'02,h'53,h'02,h'53,h'02
                      .db h'54,h'02,h'54,h'02,h'55,h'02,h'55,h'02
                      .db h'56,h'02,h'56,h'02,h'57,h'02,h'58,h'02
                      .db h'58,h'02,h'59,h'02,h'59,h'02,h'5A,h'02
                      .db h'5A,h'02,h'5B,h'02,h'5B,h'02,h'5C,h'02
                      .db h'5C,h'02,h'5D,h'02,h'5E,h'02,h'5E,h'02
                      .db h'5F,h'02,h'5F,h'02,h'60,h'02,h'60,h'02
                      .db h'61,h'02,h'61,h'02,h'62,h'02,h'62,h'02
                      .db h'63,h'02,h'64,h'02,h'64,h'02,h'65,h'02
                      .db h'65,h'02,h'66,h'02,h'66,h'02,h'67,h'02
                      .db h'67,h'02,h'68,h'02,h'69,h'02,h'69,h'02
                      .db h'6A,h'02,h'6A,h'02,h'6B,h'02,h'6B,h'02
                      .db h'6C,h'02,h'6C,h'02,h'6D,h'02,h'6E,h'02
                      .db h'6E,h'02,h'6F,h'02,h'6F,h'02,h'70,h'02
                      .db h'70,h'02,h'71,h'02,h'72,h'02,h'72,h'02
                      .db h'73,h'02,h'73,h'02,h'74,h'02,h'74,h'02
                      .db h'75,h'02,h'75,h'02,h'76,h'02,h'77,h'02
                      .db h'77,h'02,h'78,h'02,h'78,h'02,h'79,h'02
                      .db h'79,h'02,h'7A,h'02,h'7B,h'02,h'7B,h'02
                      .db h'7C,h'02,h'7C,h'02,h'7D,h'02,h'7D,h'02
                      .db h'7E,h'02,h'7F,h'02,h'7F,h'02,h'80,h'02
                      .db h'80,h'02,h'81,h'02,h'82,h'02,h'82,h'02
                      .db h'83,h'02,h'83,h'02,h'84,h'02,h'84,h'02
                      .db h'85,h'02,h'86,h'02,h'86,h'02,h'87,h'02
                      .db h'87,h'02,h'88,h'02,h'89,h'02,h'89,h'02
                      .db h'8A,h'02,h'8A,h'02,h'8B,h'02,h'8B,h'02
                      .db h'8C,h'02,h'8D,h'02,h'8D,h'02,h'8E,h'02
                      .db h'8E,h'02,h'8F,h'02,h'90,h'02,h'90,h'02
                      .db h'91,h'02,h'91,h'02,h'92,h'02,h'93,h'02
                      .db h'93,h'02,h'94,h'02,h'94,h'02,h'95,h'02
                      .db h'96,h'02,h'96,h'02,h'97,h'02,h'97,h'02
                      .db h'98,h'02,h'99,h'02,h'99,h'02,h'9A,h'02
                      .db h'9A,h'02,h'9B,h'02,h'9C,h'02,h'9C,h'02
                      .db h'9D,h'02,h'9D,h'02,h'9E,h'02,h'9F,h'02
                      .db h'9F,h'02,h'A0,h'02,h'A0,h'02,h'A1,h'02
                      .db h'A2,h'02,h'A2,h'02,h'A3,h'02,h'A3,h'02
                      .db h'A4,h'02,h'A5,h'02,h'A5,h'02,h'A6,h'02
                      .db h'A6,h'02,h'A7,h'02,h'A8,h'02,h'A8,h'02
                      .db h'A9,h'02,h'AA,h'02,h'AA,h'02,h'AB,h'02
                      .db h'AB,h'02,h'AC,h'02,h'AD,h'02,h'AD,h'02


;prec_mode:                     mvi a,12
;                     call hlbya     ; l holds octave, acc holds note
;                     
;                     mvi e,0
;                     ana a
;                     rar
;                     mov d,a
;                     mov a,e
;                     rar
;                     mov e,a          ;de holds correct table offset
;                     push b
;                     push h
;                     lxi h,bend
;                     mvi b,0
;                     dad b
;                     mov a,m
;                     rrc
;                     ani h'7f
;                     mov l,a
;                     mvi h,0
;                     dad d
;                     mvi a,h'fe
;                     ana l
;                     mov l,a
;                     pop d
;                     lxi b,notes
;                     dad b            ;get offset
;                     mov a,m
;                     inx h
;                     pop b
;


;rst4:                     mvi h,0
;                     mvi a,12
;                     call hlbya     ; l holds octave, acc holds note
;                     
;                     mvi e,0
;                     ana a
;                     rar
;                     mov d,a
;                     mov a,e
;                     rar
;                     mov e,a          ;de holds correct table offset
;                     push b
;                     push h
;                     lxi h,bend
;                     mvi b,0
;                     dad b
;                     mov a,m
;                     rrc
;                     ani h'7f
;                     mov l,a
;                     mvi h,0
;                     dad d
;                     mvi a,h'fe
;                     ana l
;                     mov l,a
;                     pop d
;                     lxi b,notes
;                     dad b            ;get offset
;                     mov a,m
;                     inx h
;                     pop b
;

;its_ok:                     mvi a,12
;                     call hlbya       ;l holds octave, a holds note
;                                      ;correct up to here
;                     
;                     
;                     mvi e,0
;                     ana a
;                     rar
;                     mov d,a
;                     mov a,e
;                     rar
;                     mov e,a          ;de holds correct table offset
;                     push b
;                     push h
;                     lxi h,bend
;                     mvi b,0
;                     dad b
;                     mov a,m
;                     rrc
;                     ani h'7f
;                     mov l,a
;                     mvi h,0
;                     dad d
;                     mvi a,h'fe
;                     ana l
;                     mov l,a
;                     pop d
;                     lxi b,notes
;                     dad b            ;get offset
;                     mov a,m
;                     inx h
;                     pop b
;
                 ;    push b
                 ;    pop h

;                     mvi a,h'80
;                     mvi h,0
;                     ana l
;                     jz no_neg
;                     mvi h,h'ff
                     
;no_neg:              dad b           ;add/sub note to bend value hl=result
;                     mvi a,h'80
;                     ana h
;                     jz not_small
;                     lxi b,1536
;                     dad b
;                     dcr d
;                     jmp not_smallout
                  
;not_small:           push h
;                     lxi b,-1536
;                     dad b
;                     jnc not_big
;                     inr d
;                     jmp not_smallout

;not_big:             pop h

;not_smallout:        ana a
                   ;  mov a,h
                   ;  rar
                   ;  mov b,a
                   ;  mov a,l
                   ;  rar
                   ;  mov c,a         ;div by 2 and cast off unused bit

                     .org h'1fff
                     .db 0

                     .org h'8000

mode:                .rs 1     ; music mode- 0=melodic 1=percussive

num_ins:             .rs 1     ; number of instruments

chan0:               .rs 32    ; channel pointers

bend:                .rs 16    ; pitch bend info

old0:                .rs 16    ; reg 40 shadow
old1:                .rs 16    ; reg 43 shadow
old2:                .rs 16    ; reg c0 shadow
old3:                .rs 16    ; reg b0 shadow

bd_reg:              .rs 1     ; reg bd shadow

old_notes:           .rs 16    ; old note value shadows for pitch bends

old_notes2:          .rs 16    ; old note value shadows for repeats

old_vol:             .rs 16    ; old volume shadows

start_ins:           .rs 2     ; pointer to start of instruments

dlay:                .rs 32    ; delay values for channels
old_dlay:            .rs 32    ; old delay values

 .org H'c000

                 ;mul h by b  result in hl


