; The processor I used was the 8085, running at 8 Mhz.
; I mapped the display into I/O space @ h'80.
; The RS line goes to A0
; The /WR and /RD lines of the display are both OR'ed with the /EN
; signal from the I/O decoder. 
; To make life simpiler, set the display up for '80- series mode' by
; shorting the jumper marked 'MPU' or 'JP 2' (There are 2 different models
; of display).  
; That's it!
; This program was designed to run in RAM, starting at h'c000
; 
; This code is dirty because it was never meant for distribution! ;-)
;
; It worked fine as of 10/19/95
;





; Does a cool display demo
; using the brightness control, etc.

 .org h'c000
 .equ display,h'00

start:       mvi a,h'30
             out display
             mvi a,h'c
             out display
             call wait
             mvi a,1
             out display
             
           ;  jmp next_2
             
             lxi h,ms_1
             call string
             lxi d,40

loop:        rim
             ani h'80
             rz
             dcx d
             mov a,d
             ora e
             jz next_0
             inr c
             mov a,c
             ani 4
             mvi a,0
             jz skip_f
             cma

skip_f:      ani 3
             xra c
             mov b,a
             mvi a,h'30
             out display
             call wait
             mov a,b
             out display+1
             lxi h,h'4000
             
sf_loop:     dcx h
             mov a,h
             ora l
             jnz sf_loop
             jmp loop

next_0:      lxi h,breakup+1
             
n0_loop:     mov a,m
             ora a
             jz next_1
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             inx h
             lxi d,h'4000
             call dlay
             inr c
             mov a,c
             ani 4
             mvi a,0
             jz skip_ff
             cma

skip_ff:     ani 3
             xra c
             mov b,a
             mvi a,h'30
             out display
             call wait
             mov a,b
             out display+1
             jmp n0_loop

next_1:      mvi c,3

n1_loop:     mvi a,1
             out display
             call wait
             lxi h,ms_2
             call string
             mov a,c
             rlc
             rlc
             ani h'c
             add c
             mov e,a
             mvi d,0
             lxi h,ms_3
             dad d
             call string
             mvi b,0
             lxi h,vals
             dad b
             mov a,m
             call bar
             mvi a,h'30
             out display
             call wait
             mov a,c
             out display+1
             call wait
             push d
             lxi d,0
             call dlay
             call dlay
             call dlay
             call dlay
             pop d
             dcr c
             mov a,c
             cpi h'ff
             jnz n1_loop
             lxi h,breakup+1
             
n11_loop:    mov a,m
             ora a
             jz next_2
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             inx h
             lxi d,h'800
             
n12_loop:    dcx d
             mov a,d
             ora e
             jnz n12_loop
             jmp n11_loop

next_2:      lxi d,0
             call dlay
             lxi h,ms_4
             call string
             mvi c,0

n2_loop:     mvi a,h'8e
             out display
             call wait
             mvi d,h'ff
             mov a,c

n20_loop:    mov b,a
             inr d
             sui 10
             jnc n20_loop
             mvi a,'0'
             add d
             out display+1
             call wait
             mvi a,'0'
             add b
             out display+1
             call wait
             mvi a,'%'
             out display+1
             mov a,c
             call bar
             lxi h,h'2000
             
n21_loop:    dcx h
             mov a,h
             ora l
             jnz n21_loop
             inr c
             mvi a,100
             cmp c
             jnz n2_loop
             lxi d,0
             call dlay
             mvi a,1
             out display
             call wait
             lxi h,ms_5
             call string
             mvi c,0

n3_loop:     mvi a,h'c0
             out display
             call wait
             mov a,c
             mvi b,20
             
n30_loop:    out display+1
             push psw
             call wait
             pop psw
             inr a
             dcr b
             jnz n30_loop
             lxi d,h'4000
             call dlay
             inr c
             jnz n3_loop
             lxi d,h'8000
             call dlay
             mvi b,h'80
             mvi c,h'd3
             
n31_loop:    mov a,b
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             mov a,c
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             lxi d,4000
             call dlay
             inr b
             dcr c
             mvi a,h'bf
             cmp c
             jnz n31_loop
             mvi a,1
             out display
             call wait
             lxi h,ms_7
             call string
             mvi b,20

n4_loop:     mvi a,h'80
             out display
             call wait
             mov a,b
             ani 1
             push psw
             cz sho_blnk
             pop psw
             cnz sho_err
             lxi d,h'c000
             call dlay
             dcr b
             jnz n4_loop
             lxi h,breakup+1
             
n40_loop:    mov a,m
             ora a
             jz next_5
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             inx h
             lxi d,h'1000
             call dlay
             jmp n40_loop

next_5:      mvi c,0
             mvi b,0
             mvi d,100
             
n5_loop:     mvi a,h'80
             out display
             call wait
             lxi h,ms_9
             dad b
             call string2
             inr c
             mvi a,3
             cmp c
             cz rset_c
             mvi a,h'c0
             out display
             call wait
             push b
             mov a,c
             cma
             ani h'3
             dcr a
             mov c,a
             lxi h,ms_9
             dad b
             call string2
             pop b
             push d
             lxi d,h'3000
             call dlay
             pop d
             dcr d
             jnz n5_loop
             lxi h,breakup+1
             
n50_loop:    mov a,m
             ora a
             jz next_6
             push psw
             out display
             call wait
             mvi a,'*'
             out display+1
             call wait
             lxi d,h'2000
             call dlay
             pop psw
             push psw
             out display
             call wait
             mvi a,h'a5
             out display+1
             call wait
             lxi d,h'2000
             call dlay
             pop psw
             out display
             call wait
             mvi a,' '
             out display+1
             call wait
             inx h
             lxi d,h'5000
             call dlay
             jmp n50_loop
             
next_6:      mvi a,1
             out display
             call wait
             lxi h,ms_10
             call string
             mvi b,10

dd_loop:     lxi d,0
             call dlay
             dcr b
             jnz dd_loop
             jmp start

rset_c:      mvi c,0
             ret

sho_blnk:    lxi h,ms_8
             jmp string

sho_err:     lxi h,ms_6
             jmp string














string:      call wait
             in display
             cpi 20
             cz newline
             mov a,m
             ora a
             rz
             out display+1
             call wait
             inx h
             jmp string

string2:     call wait
             mov a,m
             ora a
             rz
             out display+1
             call wait
             inx h
             jmp string2


newline:     mvi a,h'c0
             out display
             call wait
             ret

dlay:        dcx d
             mov a,d
             ora e
             jnz dlay
             ret

wait:        in display
             ani h'80
             jnz wait
             ret

; a=level
; a=0 to 100

bar:         push psw
             mvi a,h'c0
             out display
             call wait
             pop psw

ba_loop:     mov b,a
             sui 5
             jc no_sho
             push psw
             mvi a,h'14
             out display+1
             call wait
             pop psw
             jmp ba_loop
             
no_sho:      mov a,b
             ora a
             rz
             adi h'0f
             out display+1
             call wait
             ret

                 ;0123456789abcdef0123
                 ;98765432100123456789
ms_1:        .db "       Display      "
             .db "      Mega-Demo     ",0

ms_2:        .db "  Brightness: ",0

ms_3:        .db "100%\0 75%\0 50%\0 25%\0"

ms_4:        .db "    Level: \0"

ms_5:        .db "   Character Set\0"

ms_6:        .db " ERROR\0"
ms_8:        .db "       \0"
ms_7:        .db "         Continue?  "
             .db h'1e,"Yes             No",h'1d,0

ms_10:       .db " That's all, folks! "
             .db "      ->KEH<-       ",0

ms_9:        .db h'95,h'95,h'94,h'95,h'95,h'94,h'95,h'95,h'94
             .db h'95,h'95,h'94,h'95,h'95,h'94,h'95,h'95,h'94
             .db h'95,h'95,h'94,h'95,h'95,h'94,h'95,h'95,h'94
             .db h'0

vals:        .db 100,75,50,25

breakup:     .db h'00,h'89,h'90,h'c3,h'd3,h'c8,h'80,h'8d,h'cb,h'86,h'cf
             .db h'ca,h'88,h'c5,h'81,h'd2,h'8f,h'c6,h'8b,h'cc,h'c0
             .db h'8a,h'93,h'c7,h'8e,h'c1,h'92,h'd0,h'c9,h'83,h'84
             .db h'c2,h'91,h'8c,h'c4,h'87,h'cd,h'd1,h'85,h'ce,h'82,h'00
